//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Automates cellulaires autoreproducteurs  (Vuibert)
//    v:0.1 07/09/2002
//
//  This program demonstrates a celular automata devoted to self-reproduction
//  It is based on :
//      Morita K., Imai K.,  A Simple Self-Reproducing Cellular Automaton
//      whith Shape-Encoding Mechanism , Artificial Life V, Proceedings of
//      fifth International Workshop on the Synthesis and Simulation of Living
//      Systems, MIT Press, Cambridge, 1997.
//      http://kepi.ke.sys.hiroshima-u.ac.jp/projects/ca/sr/
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package ar;

import java.awt.*;
import java.awt.event.*;
import vabase.*;

/** La classe arUI est l'interface de l'automate cellulaire */
public class arUI extends Cui {

  /** L'automate cellulaire */
  Cac ac;

  // Elments d'interface
  Button btnPas = new Button();
  Button btnGo = new Button();
  Label lbGeneration = new Label();
  Button btnEfface = new Button();
  GridLayout gridLayout1 = new GridLayout();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Label label3 = new Label();
  Choice chFigures = new Choice();
  Choice chTailles = new Choice();
  GridLayout gridLayout5 = new GridLayout();
  GridLayout gridLayout6 = new GridLayout();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Label label2 = new Label();
  Panel panelVue = new Panel();
  GridLayout gridLayout4 = new GridLayout();
  Panel panel5 = new Panel();
  GridLayout gridLayout7 = new GridLayout();
  Label label1 = new Label();
  Panel panel8 = new Panel();
  GridLayout gridLayout8 = new GridLayout();

  /** Constructeur : cre l'automate, etc... */
  public arUI(arLaunch am) {
    super((Claunch)am);
    ac=new Cac(this, Cac.TAILLE_DEFAUT, Cac.TAILLE_DEFAUT);
    process=(Cprocess)ac;
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /** Initialisation */
  private void jbInit() throws Exception {
    panel2.setLayout(gridLayout1);
    gridLayout3.setColumns(4);
    gridLayout2.setColumns(3);
    gridLayout1.setColumns(4);
    btnEfface.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnEfface_actionPerformed(e);
      }
    });
    btnEfface.setLabel("Efface");
    lbGeneration.setText("0");
    btnGo.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnGo_actionPerformed(e);
      }
    });
    btnGo.setLabel("Go");
    btnPas.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnPas_actionPerformed(e);
      }
    });
    btnPas.setLabel("Pas");
    panel3.setLayout(gridLayout2);
    panel4.setLayout(gridLayout3);
    label3.setAlignment(1);
    label3.setText("Gnration...");
    lbGeneration.setText("0");
    chFigures.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        chFigures_itemStateChanged(e);
      }
    });
    chTailles.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        chTailles_itemStateChanged(e);
      }
    });
    gridLayout5.setColumns(2);
    gridLayout5.setHgap(4);
    gridLayout6.setColumns(2);
    gridLayout6.setHgap(4);
    panel6.setLayout(gridLayout5);
    panel7.setLayout(gridLayout6);
    label2.setAlignment(1);
    label2.setText("Figures... ");
    panelVue.setLayout(gridLayout4);
    panelVue.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        panelVue_componentResized(e);
      }
    });
    panel5.setLayout(gridLayout7);
    gridLayout7.setColumns(3);
    label1.setAlignment(1);
    label1.setText("Taille...");
    panel8.setLayout(gridLayout8);
    this.add(panel2, BorderLayout.SOUTH);
    panel2.add(panel3, null);
    panel3.add(btnGo, null);
    panel3.add(btnPas, null);
    panel3.add(btnEfface, null);
    panel2.add(panel4, null);
    panel4.add(label3, null);
    panel4.add(lbGeneration, null);
    panel4.add(panel8, null);
    this.add(panel6, BorderLayout.NORTH);
    panel6.add(panel5, null);
    panel6.add(panel7, null);
    panel7.add(chFigures, null);
    panel5.add(label1, null);
    panel5.add(chTailles, null);
    panel5.add(label2, null);
    this.add(panelVue, BorderLayout.CENTER);
    chFigures.addItem("Le plus petit vers autorplicateur");
    chFigures.addItem("3 vers");
    chFigures.addItem("Un vers en forme de 7");
    chFigures.addItem("Un vers en forme de S");
    chFigures.addItem("La plus petite boucle");
    chFigures.addItem("Une boucle complexe");
    chFigures.select(0);
    chTailles.addItem("25");
    chTailles.addItem("50");
    chTailles.addItem("75");
    chTailles.addItem("100");
    chTailles.select(1);
    // Ajout de la vue dans un panel
    panelVue.add(ac.arVue,null);
  }
  /** Initialisation du monde */
  public void start() {
    super.start();
//    ac.ajoutFigure(1);
    ac.ajoutFigure(chFigures.getSelectedIndex());
  }

  /** Avance pas  pas */
  void btnPas_actionPerformed(ActionEvent e) {
    ac.pasAPas();
  }
  /** Marche/Arrt */
  void btnGo_actionPerformed(ActionEvent e) {
    if(ac.isRunning==false) {
      btnGo.setLabel("Stop");
      setInterface(false);
      ac.lancement();
    }
    else {
      btnGo.setLabel("Go");
      ac.stop();
      setInterface(true);
    }
  }
  /** Efface grille */
  void btnEfface_actionPerformed(ActionEvent e) {
    ac.effaceGrille();
    affGeneration();
  }
  /** Choix figure */
  void chFigures_itemStateChanged(ItemEvent e) {
    ac.ajoutFigure(chFigures.getSelectedIndex());
    affGeneration();
  }
  /** Choix taille automate */
  void chTailles_itemStateChanged(ItemEvent e) {
    int t=Integer.parseInt(chTailles.getSelectedItem());
    ac.setTaille(t, t);
    affGeneration();
  }
  /** Redimensionnement de la vue */
  void panelVue_componentResized(ComponentEvent e) {
    redimUi();
  }

  /** Affichage gnration */
  public void affGeneration() {
    lbGeneration.setText(Integer.toString(ac.generation));
  }
  /** (in)activation interface */
  public void setInterface(boolean e) {
    btnPas.setEnabled(e);
    btnEfface.setEnabled(e);
    chFigures.setEnabled(e);
    chTailles.setEnabled(e);
  }
}