//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Automates cellulaires autoreproducteurs  (Vuibert)
//    v:0.1 07/09/2002
//
//  This program demonstrates a celular automata devoted to self-reproduction
//  It is based on :
//      Morita K., Imai K.,  A Simple Self-Reproducing Cellular Automaton
//      whith Shape-Encoding Mechanism , Artificial Life V, Proceedings of
//      fifth International Workshop on the Synthesis and Simulation of Living
//      Systems, MIT Press, Cambridge, 1997.
//      http://kepi.ke.sys.hiroshima-u.ac.jp/projects/ca/sr/
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package ar;

import java.awt.*;
import vabase.*;

/** Classe de gestion de vue, base graphique */
public class vueAr extends Cvue {

  /** Pointeur sur l'automate */
  private Cac acPere;
  /** Taille d'une cellule */
  private float tailleCellHoriz, tailleCellVertic;
  private float offsTailleCaseH, offsTailleCaseV;
  private int largeurCell, hauteurCell;
  /** Nombre de cellules affiches */
  private int nbCellHoriz, nbCellVertic;
  /** Tableau pour affichage caractres */
  private char[] CarCel;

  /** Constructeur par dfaut */
  public vueAr(Cac ac) {
    super(Color.black, Color.white, Cvue.REPRANISOTROPIC);
    acPere=ac;
    setForeground(Color.red);
    CarCel=new char[2];
  }
  /** Constructeur avec fond */
  public vueAr(Cac ac, Color c, Color f) {
    super(c, f, Cvue.REPRANISOTROPIC);
    acPere=ac;
    CarCel=new char[2];
    setForeground(Color.red);
  }
  /** Fixe nouvelle taille */
  public void setNewTaille() {
    redimGrBuff();
    setTailleCell(acPere.grille.getNbCellHoriz(), acPere.grille.getNbCellVertic());
    peintFond();
    acPere.grille.affGrille();
    repaint();
  }
  /** Fixe la taille des cellules, reoit le nombre horiz/vertic */
  public void setTailleCell(int nbh, int nbv) {
    nbCellHoriz=nbh;
    nbCellVertic=nbv;
    tailleCellHoriz=lLargeur/nbCellHoriz;
    tailleCellVertic=lHauteur/nbCellVertic;
    offsTailleCaseH= (tailleCellHoriz>4.0F ? 1.0F : 0.0F);
    offsTailleCaseV= (tailleCellVertic>4.0F ? 1.0F : 0.0F);
    largeurCell=Math.max(lLongueurToRX(tailleCellHoriz-2*offsTailleCaseH)-1,1);
    hauteurCell=Math.max(lLongueurToRY(tailleCellVertic-2*offsTailleCaseV)-1,1);
    grBuff.setFont((new Font(grBuff.getFont().getName(),
                                      Font.PLAIN, lLongueurToRY(tailleCellVertic))));
  }

  /** Affiche une cellule */
  public void affCell(int x, int y, byte et) {
    int offsTailleCaseH= (int) (tailleCellHoriz>3 ? tailleCellHoriz/5 : 0);
    int offsTailleCaseV= (int) (tailleCellVertic>3 ? 1 : 0);
    offsTailleCaseH=0;
    offsTailleCaseV=0;
    if((char)et=='#')
      return;
    grBuff.setColor(Color.black);
    CarCel[0]=(char)et;

    grBuff.setColor(Color.black);
    grBuff.drawChars(CarCel,0,1,lToRX(x*tailleCellHoriz),
                      lToRY(y*tailleCellVertic));

  }

  /** Peint le fond */
  public void peintFond() {
    effaceFond();
  }
  /** Modification d'une cellule avec la souris */
  public boolean mouseDown(Event e,int x,int y) {
    if(acPere.isRunning)
      return(false);
    int posx=(int)(rToLX(x)/tailleCellHoriz);
    int posy=(int)(rToLY(y)/tailleCellVertic);
    if(posx<0 || posx>acPere.grille.getNbCellHoriz()-1 ||
          posy<0 || posy>acPere.grille.getNbCellVertic()-1)
            return false;

    char ccrt=(char)acPere.grille.getCellule(posx, posy);
    int ncrt=0;
    for(int i=0;i<Cac.MAXNBETATS;i++) {
      if(ccrt==Cregles.etats[i])
        ncrt=i;
    }
    acPere.grille.setCellule(posx, posy,
          (byte)Cregles.etats[(ncrt+1)%(Cac.MAXNBETATS)]);
    acPere.grille.affGrille();
    repaint();
    return true;
  }
  /** Affichage grille de fond */
  public void affGr(boolean ag) {
  }
}


